<template>
    <div class="row">
        <div class="col-md-4" v-for="post in posts" :key="post.id">
            <div class="card mb-4 box-shadow">
                <v-lazy-image
                    v-if="post.img_base64"
                    :src="'data:image/jpeg;base64,'+ post.img_base64[0]"
                    style="height: 225px; width: 100%; display: block;"
                ></v-lazy-image>
                <div class="card-body">
                    <h5 class="card-title">{{post.title}}</h5>
                    <p class="card-text" v-html="post.teaser"></p>
                    <div class="d-flex justify-content-between align-items-center">
                        <div class="btn-group">
                            <router-link :to="`/post/${post.id}`" class="btn btn-sm btn-info">View</router-link>
                            <button type="button" v-if="currentUser === post.author_id" @click="deletePost(post.id)"
                                    class="btn btn-sm btn-danger">Delete
                            </button>
                        </div>
                        <small class="text-muted">{{post.author}} | {{post.date}}</small>

                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import VLazyImage from "v-lazy-image";

    export default {
        name: "ListPosts",
        components: {
            VLazyImage
        },
        mounted() {
            if (this.posts.length) {
                return;
            }
            this.$store.dispatch('getPosts');

        },
        computed: {
            currentUser() {
                if(this.$store.getters.currentUser !== null) {
                    return this.$store.getters.currentUser.id;
                }
                return 0;
            },
            posts() {
                return this.$store.getters.posts;
            }
        },
        methods: {
            deletePost(id) {
                console.log(id);
                this.$store.dispatch('deletePost', {id: id});
            }
        },
    }
</script>

<style scoped>

</style>
